config/routes.rb
Rails.application.routes.draw do

  resources :diplomas
  devise_for :centers,
             :path=>'recruteur',
             :path_names=>{:sign_in=>'login', :edit=>'profile'},
             :controllers=>{
                 :registrations=>'centers/registrations',
                 :sessions=>'centers/sessions'
             }

  devise_for :users,
             :path=>'',
             :path_names=>{:sign_in=>'login', :sign_out=>'logout', :edit=>'profile'},
             :controllers=>{
                 :registrations=>'users/registrations',
                 :sessions=>'users/sessions'
             }

  resources :users do
    get :matching_offers
  end
  resources :centers
  resources :availabilities
  resources :circonscriptions
  resources :offers
  resources :schools

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  # root page of the application
  root 'pages#home'

  get '/search' => 'pages#search'
end

app/models/diploma.rb
class Diploma < ApplicationRecord
  has_and_belongs_to_many :offers, dependent: :destroy
end

app/controllers/diplomas_controller.rb
class DiplomasController < ApplicationController
  before_action :set_diploma, only: [:show, :edit, :update, :destroy]

  # GET /diplomas
  # GET /diplomas.json
  def index
    @diplomas = Diploma.all
  end

  # GET /diplomas/1
  # GET /diplomas/1.json
  def show
  end

  # GET /diplomas/new
  def new
    @diploma = Diploma.new
  end

  # GET /diplomas/1/edit
  def edit
  end

  # POST /diplomas
  # POST /diplomas.json
  def create
    @diploma = Diploma.new(diploma_params)

    respond_to do |format|
      if @diploma.save
        format.html { redirect_to @diploma, notice: 'Diploma was successfully created.' }
        format.json { render :show, status: :created, location: @diploma }
      else
        format.html { render :new }
        format.json { render json: @diploma.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /diplomas/1
  # PATCH/PUT /diplomas/1.json
  def update
    respond_to do |format|
      if @diploma.update(diploma_params)
        format.html { redirect_to @diploma, notice: 'Diploma was successfully updated.' }
        format.json { render :show, status: :ok, location: @diploma }
      else
        format.html { render :edit }
        format.json { render json: @diploma.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /diplomas/1
  # DELETE /diplomas/1.json
  def destroy
    @diploma.destroy
    respond_to do |format|
      format.html { redirect_to diplomas_url, notice: 'Diploma was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_diploma
      @diploma = Diploma.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def diploma_params
      params.require(:diploma).permit(:name)
    end
end

app/helpers/diplomas_helper.rb
module DiplomasHelper
end

app/views/diplomas/_form.html.erb
<%= form_with(model: diploma, local: true) do |form| %>
  <% if diploma.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(diploma.errors.count, "error") %> prohibited this diploma from being saved:</h2>

      <ul>
      <% diploma.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :diploma_name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/diplomas/edit.html.erb
<h1>Editing Diploma</h1>

<%= render 'form', diploma: @diploma %>

<%= link_to 'Show', @diploma %> |
<%= link_to 'Back', diplomas_path %>

app/views/diplomas/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Diplomas</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @diplomas.each do |diploma| %>
      <tr>
        <td><%= diploma.name %></td>
        <td><%= link_to 'Show', diploma %></td>
        <td><%= link_to 'Edit', edit_diploma_path(diploma) %></td>
        <td><%= link_to 'Destroy', diploma, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Diploma', new_diploma_path %>

app/views/diplomas/new.html.erb
<h1>New Diploma</h1>

<%= render 'form', diploma: @diploma %>

<%= link_to 'Back', diplomas_path %>

app/views/diplomas/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @diploma.name %>
</p>

<%= link_to 'Edit', edit_diploma_path(@diploma) %> |
<%= link_to 'Back', diplomas_path %>